using System;
using System.Collections;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	[Serializable]
	public class NameValue
	{
		private string _name;
		private string _value;
		public string Name
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}
		public string Value
		{
			get
			{
				return _value;
			}
			set
			{
				_value = value;
			}
		}
	}

	public class NameValueCollection : CollectionBase
	{
		#region Public Constructors
		/// <summary>
		/// Default constructor.
		/// </summary>
		public NameValueCollection()
		{
		}

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="capacity"></param>
		public NameValueCollection(int capacity)
		{
			InnerList.Capacity = capacity;
		}
		#endregion

		#region Public Properties

		/// <summary>
		/// Gets or sets a NameValue object from the collection by the specified index.
		/// </summary>
		public NameValue this[int index]
		{
			get { return (NameValue)List[index]; }
			set { List[index] = value; }
		}

		/// <summary>
		/// Gets an object that can be used to synchronize access to the CollectionBase.
		/// </summary>
		public object SyncRoot
		{
			get { return this; }
		}

		#endregion

		#region Public Methods
		/// <summary>
		/// Adds the specified NameValue object to the collection.
		/// </summary>
		public void Add(NameValue value)
		{
			List.Add(value);
		}

		/// <summary>
		/// Provide the strongly typed member for ICollection.
		/// </summary>
		/// <param name="value"></param>
		/// <returns></returns>
		public bool Contains(NameValue value) 
		{
			return List.Contains(value);
		}

		/// <summary>
		/// Provide the strongly typed member for ICollection.
		/// </summary>
		/// <param name="array"></param>
		/// <param name="index"></param>
		public void CopyTo(NameValue[] array, int index)
		{
			List.CopyTo(array, index);
		}

		/// <summary>
		/// Provide the strongly typed member for ICollection.
		/// </summary>
		/// <param name="index"></param>
		/// <param name="value"></param>
		public void Insert(int index, NameValue value) 
		{
			List.Insert(index, value);
		}

		/// <summary>
		/// Provide the strongly typed member for ICollection.
		/// </summary>
		/// <param name="value"></param>
		/// <returns></returns>
		public int IndexOf(NameValue value) 
		{
			return List.IndexOf(value);
		}
    
		/// <summary>
		/// Removes the specified NameValue object from the collection.
		/// </summary>
		public void Remove(NameValue value)
		{
			List.Remove(value);
		}

		/// <summary>
		/// Sorts the collection.
		/// </summary>
		public void Sort()
		{
			InnerList.Sort();
		}

		/// <summary>
		/// Sorts the collection.
		/// </summary>
		public void Sort(IComparer comparer)
		{
			InnerList.Sort(comparer);
		}

		/// <summary>
		/// Sorts the collection.
		/// </summary>
		public void Sort(int index, int count, IComparer comparer)
		{
			InnerList.Sort(index, count, comparer);
		}
		#endregion
	}
}
