using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Text.RegularExpressions;
using System.Windows.Forms;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox1;
		private Hashtable _valueControls = new Hashtable();
		
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InitializeGrid();

			NameValueCollection col = new NameValueCollection();
			
			NameValue nv = new NameValue();
			nv.Name = "Davolio";
			nv.Value = "Nancy";
			col.Add(nv);

			nv = new NameValue();
			nv.Name = "Fuller";
			nv.Value = "Andrew";
			col.Add(nv);

            gridGroupingControl1.DataSource = col;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(344, 216);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.50";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(16, 240);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 272);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "textBox1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 406);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.Run(new Form1());
		}


		private void InitializeGrid()
		{
			gridGroupingControl1.TableDescriptor.Columns.Add("Name", "Name");
			gridGroupingControl1.TableDescriptor.Columns.Add("Value", "Value");
			
			gridGroupingControl1.Appearance.AnyCell.AutoSize = true;
			gridGroupingControl1.Appearance.AnyCell.Enabled = false;
			gridGroupingControl1.Appearance.AnyCell.CellType = "Static";
			gridGroupingControl1.Appearance.AnyCell.WrapText = false;
			gridGroupingControl1.Appearance.AnyCell.Borders.Top =
				gridGroupingControl1.Appearance.AnyCell.Borders.Left =
				gridGroupingControl1.Appearance.AnyCell.Borders.Right =
				gridGroupingControl1.Appearance.AnyCell.Borders.Bottom = new GridBorder(GridBorderStyle.NotSet);

			gridGroupingControl1.TableOptions.ShowRowHeader = false;

			gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
			gridGroupingControl1.TopLevelGroupOptions.ShowColumnHeaders = false;
			gridGroupingControl1.TopLevelGroupOptions.ShowSummaries = false;

			/* Support's code
			 */
			gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.CellType="Static";

			gridGroupingControl1.TableDescriptor.Appearance.AnyHeaderCell.CellType="Static";

			GridStyleInfo style = new GridStyleInfo(); 
			GridBorder gb = new GridBorder(GridBorderStyle.Solid, SystemColors.ControlDark); 
			style.Borders.Bottom = gb; 
			style.Borders.Right = gb; 

			gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.ModifyStyle(style, Syncfusion.Styles.StyleModifyType.Override); 

			gridGroupingControl1.TableDescriptor.Appearance.AnyHeaderCell.ModifyStyle(style, Syncfusion.Styles.StyleModifyType.Override); 
			//set the borders for all non header cells... 

			gridGroupingControl1.TableModel.Options.DefaultGridBorderStyle = GridBorderStyle.Solid; 

			gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(OnGridQueryCellStyleInfo);
		}

		private void OnGridQueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(
				e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell ||
				e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell
				)
			{
				object data = e.TableCellIdentity.DisplayElement.GetData();
				if(data is NameValue)
				{
					NameValue nv = (NameValue)data;
					
					if(e.TableCellIdentity.Column.Name == "Value")
					{
						e.Style.CellType = "Control";
						e.Style.Control = GetValueCellControl(nv);
						e.Style.Enabled = true;

						e.Handled = true;
					}
					else
					{
						e.Style.CellValue = nv.Name;
					}
				}
			}
		}

		private Control GetValueCellControl(NameValue nv)
		{
			if(!_valueControls.Contains(nv))
			{
				Control control = CreateValueCellControl(nv);
				_valueControls[nv] = control;
			}

			return (Control)_valueControls[nv];
		}


		private Control CreateValueCellControl(NameValue nv)
		{
			TextBox textBox = new TextBox();
			textBox.DataBindings.Add("Text", nv, "Value");

			return textBox;
		}
	}
}
